#!/usr/bin/python3
# -*- coding: utf-8 -*-
"""
Packages 

Packages are a way of structuring Python’s module namespace by using “dotted
module names”. For example, the module name A.B designates a submodule named B
in a package named A. Just like the use of modules saves the authors of
different modules from having to worry about each other’s global variable
names, the use of dotted module names saves the authors of multi-module
packages like NumPy or Pillow from having to worry about each other’s module
names.

A directory that contains many modules is called a package.
A package is a module with submodules
(which can have submodules themselves, etc.).
A special file called __init__.py (which may be empty) tells Python that the
directory is a Python package, from which modules can be imported.

check out these as an example:
    '/usr/lib64/python3.8/site-packages/numpy/'
    '/usr/lib64/python3.8/site-packages/numpy/__init__.py'

Packages are a way of structuring Python’s module namespace by using
"dotted module names".
For example, the module name A.B designates
a submodule named B in a package named A.
Just like the use of modules saves the authors of different modules from having
to worry about each other’s global variable names,
the use of dotted module names saves the authors of multi-module packages
like NumPy or Pillow from having to worry about each other’s module names.

The __init__.py files are required to make Python treat directories containing
the file as packages.
This prevents directories with a common name, such as string,
unintentionally hiding valid modules that occur later on a module search path.
In the simplest case, __init__.py can just be an empty file,
but it can also execute initialization code for the package
"""

# Trace thisg
import simple_package

# Trace these
simple_package.a.bar()
simple_package.b.foo()

# For a real example, mathy stuff and nice efficient n-dimensional arrays!
import numpy as np

help(np)
print(dir(np))

# How does if name main work?
print(np.__name__)

# check out the source code of the module
print(np.__file__)
# Check out the file and directory structure now!


# +++++++++++++++ Cahoot 17.3
# https://mst.instructure.com/courses/45616/quizzes/48723
