#!/usr/bin/python3
# -*- coding: utf-8 -*-
"""
Just fibbing

Modules can import other modules. It is customary but not required to place all
import statements at the beginning of a module (or script, for that matter).
The imported module names are placed in the importing module’s global symbol
table.
"""
from typing import List


def fib(n: int) -> List[int]:
    """
    return Fibonacci series up to n
    """
    result = []
    a, b = 0, 1
    while b < n:
        result.append(b)
        a, b = b, a + b
    return result


# This happens both when importing and when running this file.
print(__name__)
print(__file__)

if __name__ == "__main__":
    # This only happens on running this file
    print(fib(7))
    print("This program is being run by itself")
else:
    # This only happens on importing this file
    print("I am being imported from another module")
